#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "main.h"


BOOLEAN LoadLibraries()
{
	hLib301 = LoadLibrary ("LL_USB2k.dll");
    if(!hLib301) return FALSE;
    return TRUE;
}

BOOLEAN InitLibFuncs()
{  
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLib301, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SetScanType =  (P_DLL_EX_SET_SCAN_TYPE)GetProcAddress(hLib301, "EX_SetScanType");
	if(!EX_SetScanType) return FALSE;
	EX_SetMultiChanScanChans =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS)GetProcAddress(hLib301, "EX_SetMultiChanScanChans");
	if(!EX_SetMultiChanScanChans) return FALSE;
	EX_SetDataLogOptions =  (P_DLL_EX_SET_DATA_LOG_OPTIONS)GetProcAddress(hLib301, "EX_SetDataLogOptions");
	if(!EX_SetDataLogOptions) return FALSE;
	EX_Run =  (P_DLL_EX_RUN)GetProcAddress(hLib301, "EX_Run");
	if(!EX_Run) return FALSE;
	EX_CheckScanStatus = (P_DLL_EX_CHECK_SCAN_STATUS)GetProcAddress(hLib301, "EX_CheckScanStatus");
	if(!EX_CheckScanStatus) return FALSE;
	EX_GetScanDataDblDigin =  (P_DLL_EX_GET_SCAN_DATA_DOUBLE_DIGIN)GetProcAddress(hLib301, "EX_GetScanDataDblDigin");
	if(!EX_GetScanDataDblDigin) return FALSE;
	EX_Stop =  (P_DLL_EX_STOP)GetProcAddress(hLib301, "EX_Stop");
	if(!EX_Stop) return FALSE;
	EX_StopComplete =  (P_DLL_EX_STOP_COMPLETE)GetProcAddress(hLib301, "EX_StopComplete");
	if(!EX_StopComplete) return FALSE;

    return TRUE;
}

// Developer NOTE:
// My IDE is set to use "__stdcall" calling convention, so the following "__cdecl" casting of main is required
int __cdecl main()
{
	USHORT usDevID = 0;
	BOOLEAN fRetVal = FALSE; BOOLEAN fRedraw = FALSE;

	if(!LoadLibraries()){ printf("Failed to load libraries"); getch(); return 0;}
	printf("Success loading libraries\n");

	if(!InitLibFuncs())
	{ printf("Failed to find required functions"); getch(); return 0;}

	printf("Success finding required functions\nConnecting -  please wait. . .");
	fRetVal = EX_Connect(&usDevID);
	if(!(fRetVal | usDevID))
	{ printf("Failed  EX_Connect()"); getch(); return 0; }
	SetCon(); // just sets up the console display

	char cUserInputVal = NULL; 
	int iKeyChar = 0;
	//char szOutVal[32], szTempBuff[32]; int iKeyChar = 0;
	BOOLEAN fScanStartSuccess = TRUE; BOOLEAN fRunning = FALSE;

	// DEVELOPER NOTE: This would be for display purposes. Since the Model 301
	//  only has 4 channels and the full-scale channel is always referred to as
	//  channel 6 and offset as channel 7 the code below could be used to display
	//  the channel number correctly even though the data is coming from the 3rd 
	//  and 4th channel regardless of the model number.
	USHORT usModel=302; BYTE b3rdChan=2; BYTE b4thChan=3;
	if(usModel==301){ b3rdChan=6; BYTE b4thChan=7; }

	while(true)
	{
		setMainScreen();
		fRedraw = FALSE;

		while((cUserInputVal != 'Q') && (cUserInputVal != 'q') && (cUserInputVal != 27) && (!fRedraw))
		{
			cUserInputVal = (char)getch();
			switch(cUserInputVal)
			{
				case 'Q': case 'q': case 27:
					printf("\nDisconnecting and exiting, please wait ....\n"); break;
				case 'R': case 'r':
					fRedraw = TRUE; system("cls"); break;
				case 'S': case 's':
					
					fScanStartSuccess = TRUE;
					ConsoleCursorInfo.bVisible = FALSE; SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);

					while(true)
					{
						if(!EX_SetScanType (usDevID, MULTI_CHAN_CAL_DIGIN_SCAN)) { fScanStartSuccess = FALSE; break; }
						if(!EX_SetMultiChanScanChans (usDevID, 7)) { fScanStartSuccess = FALSE; break; }
						if(!EX_SetDataLogOptions (usDevID, SCAN_USE_DATA_ARRAY, 0, 0)) { fScanStartSuccess = FALSE; break; }
						if(!EX_Run (usDevID)) { fScanStartSuccess = FALSE; break; }

						printf("\nScan running. Press 'E' to end run\n"); fRunning = TRUE; 
						// DEVELOPER NOTE:
						// The following loop is used to simplify the code. There are other things that can be done
						//  during a scan, for example - send digital output or read digital input, change the channel
						//  when in single-channel scan mode, send an analog output, etc.
						while(fRunning)
						{
							EX_CheckScanStatus(usDevID, &puiNumScansRemainingInBuff, &pfStillScanning, &puiStatusCode);
							gotoxy(0,11); printf("scans in buff: % 3u, code: 0x%03X, StillScanning: %s", puiNumScansRemainingInBuff, puiStatusCode, pfStillScanning > 0 ? "YES" : " NO");

							if(puiNumScansRemainingInBuff > 0)
							{
								// DEVELOPER NOTE:
								// The following will only display the first of however many scans are 
								// now ready. You will probably want to display all of the scan data
								uiNumScansToReturn = puiNumScansRemainingInBuff <= (sizeof(pdblDataBuff) / 8) ? puiNumScansRemainingInBuff : puiTotalBuffSize / 8;
								EX_GetScanDataDblDigin (usDevID, pdblDataBuff, pbDiginBuff, uiNumScansToReturn, FALSE, &puiNumScansReturned, 
									&puiNumScansRemainingInBuff, &pfStillScanning, &puiTotalBuffSize, &puiStatusCode); 
								// DEVELOPER NOTE:
								// Each of the channels below subtract the calibration (offset channel) from the actual voltage
								gotoxy(0,12); printf("chan 0: % 2.6lf,  DigitalInput: % 3u", dblDataBuff[0] - dblDataBuff[7], bDiginBuff[0]);
								gotoxy(0,13); printf("chan 1: % 2.6lf,  DigitalInput: % 3u", dblDataBuff[1] - dblDataBuff[7], bDiginBuff[1]);
								gotoxy(0,14); printf("chan 2: % 2.6lf,  DigitalInput: % 3u", dblDataBuff[2] - dblDataBuff[7], bDiginBuff[2]);
								gotoxy(0,15); printf("chan 3: % 2.6lf,  DigitalInput: % 3u", dblDataBuff[3] - dblDataBuff[7], bDiginBuff[3]);
								gotoxy(0,16); printf("chan 4: % 2.6lf,  DigitalInput: % 3u", dblDataBuff[4] - dblDataBuff[7], bDiginBuff[4]);
								gotoxy(0,17); printf("chan 5: % 2.6lf,  DigitalInput: % 3u", dblDataBuff[5] - dblDataBuff[7], bDiginBuff[5]);
								gotoxy(0,18); printf("chan 6: % 2.6lf,  DigitalInput: % 3u", dblDataBuff[6] - dblDataBuff[7], bDiginBuff[6]);

								gotoxy(0,20); printf("calibration-channel 7: % 2.6lf", dblDataBuff[7]);
							}

							if(_kbhit())
							{
								iKeyChar = getch();
								cUserInputVal = (char)iKeyChar;
								if((cUserInputVal == 27) || (cUserInputVal == 'E') || (cUserInputVal == 'e'))
								{
									gotoxy(0,22); printf("Completing scan stop - wait....");
									gotoxy(0,23); 
									if(!EX_Stop(usDevID)) printf("failed to stop scan run\n"); 
									else
									{ EX_StopComplete(usDevID); printf("\nScan Stopped.\n"); fRunning = FALSE; }
									cUserInputVal=0; break;
								}
								else
								{ gotoxy(0,22); printf("\ngot key: %c\n", (char)iKeyChar); }
							}
						}
						if(!fScanStartSuccess)
						{
							printf("\nScan failed to start. Any key to continue\n");
							getch();
						}
						setMainScreen(); 
						ConsoleCursorInfo.bVisible = TRUE; SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
						break;
					}
			}
		}
		if(!fRedraw) break;
	}
	return 1;
}

void setMainScreen(void)
{
	system("cls");
		printf("\nINITIALIZED\nPress one of the following keys:\n"
			"'Q' quit\n"
			"'R' redraw screen\n"
			"'S' start scanning\n"
			"'E' end scanning\n"
			);
}

BOOLEAN SetCon(void)
{
	hOutCon = GetStdHandle(STD_OUTPUT_HANDLE);
	if(!hOutCon)
	{
		MessageBox(0, "Error writing to console", "-- error", MB_OK);
		return FALSE;
	}
	hInCon =  GetStdHandle(STD_INPUT_HANDLE);
	if(!hInCon)
	{
		MessageBox(0, "Error reading from console", "-- error", MB_OK);
		return FALSE;
	}

	ConsoleCursorInfo.dwSize=1;
	ConsoleCursorInfo.bVisible = TRUE;
	SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
	return TRUE;
}