

//filename: mainSamp.h

HMODULE hLib301 = NULL;

void setMainScreen(void);

BOOLEAN SetCon(void);



// Developer NOTE: 

// Please see "FuncUse.html" documentation at website for information about 

// all function calls and related definitions such as the ones shown below.

#define MULTI_CHAN_CAL_DIGIN_SCAN 6

#define SCAN_USE_DATA_ARRAY 2



UINT puiNumScansRemainingInBuff, puiStatusCode, uiNumScansToReturn, puiNumScansReturned; 





// Developer NOTE:

// When doing a calibration scan, the buffer must be a size equal to at least the number of

//  channels PLUS the calibration channel. Since the calibration channel is the highest channel

//  number (4th for Model-301 and 8th for Model 302) you must always add at least one channel

//  to accomodate the data for the calibration channel.

// IMPORTANT: The calibration (also referred to as offset) channel is always the last channel

//  and is referred to as channel 7 even if you only have 4 channels as with the Model 301.

//  All channels are scanned sequentially so the only way to read the offset channel when doing

//  a scan comprised of less than the total channels for the device is to use a calibration type

//  of scan since it will read the last channel regardless of the number of channels you decide

//  to scan. Something to note is that a scan that is comprised of all the channels that the

//  device is able to scan, is no different than a calibration type of scan. The only advantage

//  to using a calibration type scan is to make it possible to read the offset channel's data

//  without having to read the total number of channels that the particular model has. 

// To better explain - if you want to scan only channel zero, but also need the highest possible 

//  accuracy possible by subtracting the offset (zero voltage), you would want to use a calibration 

//  scan setup by passing 1 as the number of channels to scan. When you read the data, the voltages

//  for channel zero will be the first element data in the data array, and the offset voltage will be

//  the second element data which you should then subtract from the channel zero data to get the actual

//  data as referenced to zero volts.

UINT puiTotalBuffSize = 16;  // MUST be sized according to number of scans you'll be reading

 

BOOLEAN pfStillScanning, fGetAllRequested; 

double dblDataBuff[16];		// MUST be sized according to number of scans you'll be reading







double* pdblDataBuff=dblDataBuff; 

BYTE bDiginBuff[16];		// MUST be sized according to number of scans you'll be reading

BYTE* pbDiginBuff=bDiginBuff; 



typedef BOOLEAN (*P_DLL_EX_CONNECT) (USHORT* usDevID);

P_DLL_EX_CONNECT EX_Connect = NULL;



typedef BOOLEAN (*P_DLL_EX_SET_SCAN_TYPE) (USHORT usDevID, BYTE bScanType);

P_DLL_EX_SET_SCAN_TYPE EX_SetScanType = NULL;



typedef BOOLEAN (*P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS) (USHORT usDevID, BYTE bChanCnt);

P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS EX_SetMultiChanScanChans = NULL;



typedef BOOLEAN (*P_DLL_EX_SET_DATA_LOG_OPTIONS) (USHORT usDevID, UINT uiDataLogMethod, UINT uiLogFileMaxSize, UINT uiMisc);

P_DLL_EX_SET_DATA_LOG_OPTIONS EX_SetDataLogOptions = NULL;



typedef BOOLEAN (*P_DLL_EX_RUN) (USHORT usDevID);

P_DLL_EX_RUN EX_Run = NULL;



typedef BOOLEAN(*P_DLL_EX_CHECK_SCAN_STATUS) (USHORT usDevID, UINT* puiNumScansRemainingInBuff, 

						   BOOLEAN* pfStillScanning, UINT* puiStatusCode);

P_DLL_EX_CHECK_SCAN_STATUS EX_CheckScanStatus = NULL;



typedef BOOLEAN (*P_DLL_EX_GET_SCAN_DATA_DOUBLE_DIGIN)( USHORT usDevID, double* pdblDataBuff, BYTE* pbDiginBuff, UINT uiNumScansToReturn,

		BOOLEAN fGetAllRequested, UINT* puiNumScansReturned, UINT* puiNumScansRemainingInBuff, 

		BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiStatusCode );

P_DLL_EX_GET_SCAN_DATA_DOUBLE_DIGIN EX_GetScanDataDblDigin = NULL;







typedef BOOLEAN (*P_DLL_EX_STOP) (USHORT usDevID);

P_DLL_EX_STOP EX_Stop = NULL;



typedef BOOLEAN (*P_DLL_EX_STOP_COMPLETE) (USHORT usDevID);

P_DLL_EX_STOP_COMPLETE EX_StopComplete = NULL;





// This is just stuff to handle the console for writing to particular line locations

HANDLE	hOutCon, hInCon;

COORD	pos, dwCursorPosition;

CONSOLE_CURSOR_INFO	ConsoleCursorInfo;

CONSOLE_SCREEN_BUFFER_INFO lpConsoleScreenBufferInfo;

DWORD	lpNumberOfCharsWritten;

#define gotoxy(x, y) pos.X = x; pos.Y = y - 1;	\

SetConsoleCursorPosition(hOutCon, pos);

#define clrscr() pos.X = 0; pos.Y = 0;		\

FillConsoleOutputCharacter(hOutCon, ' ',	\

80*25, pos, &lpNumberOfCharsWritten);









